/**
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */

/// recursive variant of the fibonacci function
fn fib_rec(x: u128) -> u128 {
    if x < 2 {
        return x;
    }

    return fib_rec(x - 1) + fib_rec(x - 2);
}

/// iterative variant of the fibonacci function
fn fib_loop(x: u128) -> u128 {
    let mut sum = 0;
    let mut sum2 = 1;

    for x in 0..(x - 1) {
        let t = sum;
        sum = sum2;
        sum2 = t + sum;
    }
    sum2
}

fn main() {
    println!("{}", fib_loop(5));
}
